SystemOrganization addCategory: #MultiColumnList!

PluggableListMorph subclass: #PluggableMultiColumnListMorphWithWrapper
	instanceVariableNames: 'gapSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiColumnList'!

!PluggableMultiColumnListMorphWithWrapper commentStamp: '<historical>' prior: 0!
A PluggableMultiColumnListMorphWithWrapper is new version of PluggableMultiColumnListMorph using wrapper!

!PluggableMultiColumnListMorphWithWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel wrapSelector: wrapSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors."

	^ self new
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: keyActionSel
		wrapSelector: wrapSel! !

!PluggableMultiColumnListMorphWithWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel wrapSelector: wrapSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors."

	^ self new
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: #arrowKey:from:	"default"
		wrapSelector: wrapSel! !

!PluggableMultiColumnListMorphWithWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
gapSize

	^ gapSize ifNil: [ gapSize := 10 ]! !

!PluggableMultiColumnListMorphWithWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
gapSize: anInteger

	gapSize := anInteger.! !

!PluggableMultiColumnListMorphWithWrapper methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
getList
	"fetch and answer the lists to be displayed"
	getListSelector == nil ifTrue: [^ #()].
	list := model perform: getListSelector.
	list == nil ifTrue: [^ #()].
	list := list collectWithIndex: [ :each :index | self wrapItem: each index: index].
	^ list! !

!PluggableMultiColumnListMorphWithWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
getListRow: row
	"return the strings that should appear in the requested row"
	getListElementSelector ifNotNil: [ ^self wrapItem: (model perform: getListElementSelector with: row) ].
	^self getList at: row! !

!PluggableMultiColumnListMorphWithWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
itemFromPoint: aPoint
	"Return the list element (morph) at the given point or nil if outside"
	| ptY |
	scroller hasSubmorphs ifFalse:[^nil].
	(scroller fullBounds containsPoint: aPoint) ifFalse:[^nil].
	ptY := (scroller firstSubmorph point: aPoint from: self) y.
	"note: following assumes that submorphs are vertical, non-overlapping, and ordered"
	scroller firstSubmorph top > ptY ifTrue:[^nil].
	scroller lastSubmorph bottom < ptY ifTrue:[^nil].
	"now use binary search"
	^scroller submorphThat: [ :item | item top <= ptY and:[item bottom >= ptY] ] ifNone: [].
! !

!PluggableMultiColumnListMorphWithWrapper methodsFor: 'searching' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
listForSearching

	^ super listForSearching collect: #first! !

!PluggableMultiColumnListMorphWithWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:58'!
listMorphClass

	^ MultiColumnLazyListMorph! !

!PluggableMultiColumnListMorphWithWrapper methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/13/2012 17:57'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel  wrapSelector: wrapSel
	self model: anObject.
	getListSelector := getListSel.
	getIndexSelector := getSelectionSel.
	setIndexSelector := setSelectionSel.
	getMenuSelector := getMenuSel.
	keystrokeActionSelector := keyActionSel.
	wrapSelector := wrapSel.
	self autoDeselect: true.
	self borderWidth: 1.
	self updateList.
	self selectionIndex: self getCurrentSelectionIndex.
	self initForKeystrokes! !

LazyListMorph subclass: #MultiColumnLazyListMorph
	instanceVariableNames: 'columnWidths wrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiColumnList'!

!MultiColumnLazyListMorph commentStamp: '<historical>' prior: 0!
A MultiColumnLazyListMorph is a new version of MulticolumnLazyListMorph using wrapper
!

!MultiColumnLazyListMorph methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:06'!
drawOn: aCanvas
	self getListSize = 0 ifTrue:[ ^self ].

	self setColumnWidthsFor: aCanvas.
	self adjustWidth.
	
	super drawOn: aCanvas! !

!MultiColumnLazyListMorph methodsFor: 'list access' stamp: 'BenjaminVanRyseghem 2/13/2012 17:22'!
font: aFont

	super font: aFont.
	wrapper font: aFont.! !

!MultiColumnLazyListMorph methodsFor: 'list access' stamp: 'BenjaminVanRyseghem 2/13/2012 16:28'!
getListItem: index

	| items |
	items := listSource getListRow: index.
	wrapper items: items.
	^ wrapper generate! !

!MultiColumnLazyListMorph methodsFor: 'list access' stamp: 'BenjaminVanRyseghem 2/13/2012 16:46'!
getRawListItem: index

	^ super getListItem: index.! !

!MultiColumnLazyListMorph methodsFor: 'scroll range' stamp: 'BenjaminVanRyseghem 2/13/2012 16:35'!
hUnadjustedScrollRange
"bvr - Introduce here the old version of the super method just waiting for this class to be deleted"

	| itemsToCheck item index |
	"Check for a cached value"
	maxWidth ifNotNil:[^maxWidth].

	listItems isEmpty ifTrue: [^0]. "don't set maxWidth if empty do will be recomputed when there are some items"
	"Compute from scratch"
	itemsToCheck := 30 min: (listItems size).
	maxWidth := 0. 

	"Check the first few items to get a representative sample of the rest of the list."
	index := 1.
	[index < itemsToCheck] whileTrue:
		[ item := self getListItem: index. "Be careful not to actually install this item"
		maxWidth := maxWidth max: (item widthToDisplayInList: self).
		index:= index + 1.
		].

	"Add some initial fudge if we didn't check all the items."
	(itemsToCheck < listItems size) ifTrue:[maxWidth := maxWidth*2].

	^maxWidth + 150
! !

!MultiColumnLazyListMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/13/2012 17:56'!
initialize
	"Initialization code for MultiColumnLazyListMorph"

	super initialize.

	columnWidths := nil.
	wrapper := MultiColumnWrapper new.! !

!MultiColumnLazyListMorph methodsFor: 'row management' stamp: 'BenjaminVanRyseghem 2/13/2012 17:55'!
listChanged

	columnWidths := nil.
	super listChanged! !

!MultiColumnLazyListMorph methodsFor: 'list access' stamp: 'BenjaminVanRyseghem 2/13/2012 16:31'!
listSource: aList

	super listSource: aList.
	wrapper gapSize: aList gapSize! !

!MultiColumnLazyListMorph methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:26'!
setColumnWidthsFor: aCanvas
        | row topRow bottomRow |
        "set columnWidths for drawing on the specified canvas"
		columnWidths ifNil: [
		columnWidths := (self getRawListItem: 1) collect: [ :ignored | 0 ]. ].
	topRow := (self topVisibleRowForCanvas: aCanvas) max: 1.
	bottomRow :=  (self bottomVisibleRowForCanvas: aCanvas) max: 1.
	topRow > bottomRow ifTrue: [ ^ self ].
	topRow to: bottomRow do: [ :rowIndex |
                row := self getRawListItem: rowIndex.
                columnWidths := columnWidths with: row collect: [ :currentWidth :item |
				| widthOfItem |
				widthOfItem := item widthToDisplayInList: self.
				widthOfItem > currentWidth
					ifTrue: [ self changed.  widthOfItem ]
					ifFalse: [ currentWidth ] ] ].
	
	wrapper widths: columnWidths.! !

Object subclass: #MultiColumnWrapper
	instanceVariableNames: 'dictionary gapSize items widths font'
	classVariableNames: 'GapSize'
	poolDictionaries: ''
	category: 'MultiColumnList'!

!MultiColumnWrapper commentStamp: '<historical>' prior: 0!
A MultiColumnWrappingMorph is a wrapper used in MultiColumn list to correcty set the different spaces

It generates WrapMorph instances!

!MultiColumnWrapper class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/12/2012 00:38'!
defaultGapSize

	^ 20! !

!MultiColumnWrapper class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/12/2012 00:38'!
gapSize

	^ GapSize ifNil: [ GapSize := self defaultGapSize ]! !

!MultiColumnWrapper methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/12/2012 14:49'!
asString

	^ items joinUsing: ' '! !

!MultiColumnWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:21'!
font

	^ font! !

!MultiColumnWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:21'!
font: aFont

	font := aFont! !

!MultiColumnWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/12/2012 01:04'!
gapSize

	^ gapSize! !

!MultiColumnWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/12/2012 01:04'!
gapSize: aNumber

	gapSize := aNumber! !

!MultiColumnWrapper methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/13/2012 17:25'!
generate
	| result fill s |
	fill := Morph new height: 0; hResizing: #spaceFill;yourself.
	result := WrapMorph new.
	s := WriteStream with: ''.
	items doWithIndex: [:each :index || morph size morphColor |
		s << each << ' '.
		morph := each asMorph font: self font.
		morphColor := morph color.
		size := (((widths at: index ifAbsent: 0) - morph width) max: 0) + self gapSize.
		result
			addMorph: morph;
			addMorph: (Morph new width: size; height: 0;yourself).
		morph color: morphColor ].
	result addMorph: fill.
	result contents: s contents.
	
	^ result! !

!MultiColumnWrapper methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/13/2012 17:21'!
initialize
	"Initialization code for MultiColumnWrappingMorph"

	super initialize.

	dictionary := Dictionary new.
	gapSize := self class gapSize.
	items := #().
	widths := #().
	font := StandardFonts listFont! !

!MultiColumnWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:03'!
items

	^ items! !

!MultiColumnWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/12/2012 01:05'!
items: aCollection

	items := aCollection! !

!MultiColumnWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 17:03'!
widths

	^ widths! !

!MultiColumnWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/12/2012 01:05'!
widths: aCollection

	widths := aCollection! !

Morph subclass: #WrapMorph
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiColumnList'!

!WrapMorph commentStamp: '<historical>' prior: 0!
A WrapMorph is a wrapper displayed in lists!

!WrapMorph methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/13/2012 17:31'!
beginsWith: aString fromList: aMorph
self halt.
	^ self contents beginsWith: aString fromList: aMorph! !

!WrapMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/12/2012 14:56'!
contents
	
	^ contents! !

!WrapMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/12/2012 14:56'!
contents: anObject
	
	contents := anObject! !

!WrapMorph methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/12/2012 14:42'!
foo

	self at: 23! !

!WrapMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/12/2012 14:57'!
initialize
	"Initialization code for WrapMorph"

	super initialize.

	contents := ''.
	
	self color: Color transparent; 
		changeTableLayout; 
		listDirection: #rightToLeft! !
